#include "testlib.h"
#include <cstdio>
#include <memory.h>
#include <cassert>
#include <algorithm>
using namespace std;

int n, mxc;

const int N = 1000500;
int P[N], W[N];
int deg[N];

void setP(int i, int p) {
    P[i] = p;
    deg[p]++;
}

void gen() {
    memset(P, -1, sizeof(int) * n);
    int freeAhead = n - 1;
    for (int i = 1; i < n; i++) {
        if (P[i] == -1) {
            --freeAhead;
again:
            int p = rnd.next(0, i - 1);
            if (deg[p] == 0 && freeAhead == 0) {
                goto again;
            }
            setP(i, p);
            if (deg[p] == 1) {
again2:
                int j = rnd.next(i + 1, n - 1);
                if (P[j] != -1) {
                    goto again2;
                }
                setP(j, p);
                freeAhead--;
            }
        }
    }
    assert(find(deg + 1, deg + n, 1) == deg + n);
    for (int i = 1; i < n; i++) {
        W[i] = rnd.next(1, mxc);
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    n = atoi(argv[1]);
    mxc = atoi(argv[2]);
    gen();
    printf("%d\n", n);
    for (int i = 1; i < n; i++) {
        printf("%d%c", P[i] + 1, " \n"[i + 1 == n]);
    }
    for (int i = 1; i < n; i++) {
        printf("%d%c", W[i], " \n"[i + 1 == n]);
    }
}
