#include "testlib.h"
#include <cstdio>
#include <memory.h>
#include <cassert>
#include <algorithm>
using namespace std;

int n, mxc;
int d;

const int N = 1000500;
int P[N], W[N];
int deg[N];

void setP(int i, int p) {
    P[i] = p;
    deg[p]++;
}

void go(int l, int r) {
    assert(r - l >= 2);
    if (r - l <= 5 + 2 * d) {
        for (int i = l + 1; i <= r; i++) {
            setP(i, l);
        }
    } else {
        int a = (r - l) / 2 + rnd.next(-d, d);
        int b = r - l - a;
        assert(a >= 2 && b >= 2);
        int m = l + a;
        setP(l + 1, l);
        setP(m + 1, l);
        go(l + 1, m);
        go(m + 1, m + b);
    }
}

void gen() {
    memset(P, -1, sizeof(int) * n);
    go(0, n - 1);
    assert(find(P + 1, P + n, -1) == P + n);
    assert(find(deg + 1, deg + n, 1) == deg + n);
    for (int i = 1; i < n; i++) {
        W[i] = rnd.next(1, mxc);
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    n = atoi(argv[1]);
    mxc = atoi(argv[2]);
    d = atoi(argv[3]);
    gen();
    printf("%d\n", n);
    for (int i = 1; i < n; i++) {
        printf("%d%c", P[i] + 1, " \n"[i + 1 == n]);
    }
    for (int i = 1; i < n; i++) {
        printf("%d%c", W[i], " \n"[i + 1 == n]);
    }
}
