#include "testlib.h"
#include <bits/stdc++.h>
using namespace std;

constexpr int MAXW = 1000 * 1000 * 1;
constexpr int MAXN = 2000 * 100;

map<string, pair<int, int>> limits = {
    {"1", {2000, 1}},
    {"2", {2000, MAXW}},
    {"3", {MAXN, 1}},
    {"4", {MAXN, MAXW}}
};

void readSpaceOrEndl(bool isEndl) {
    if (isEndl) {
        inf.readEoln();
    } else {
        inf.readSpace();
    }
}

void read(int maxn, int maxw) {
    int n = inf.readInt(3, maxn, "n");
    inf.readEoln();
    vector<int> childrenCount(n, 0);
    
    for (int i = 1; i < n; ++i) {
        ++childrenCount[inf.readInt(1, i, "p[" + to_string(i) + "]")];
        readSpaceOrEndl(i == n - 1);
    }

    for (int i = 1; i < n; ++i) {
        ensuref(childrenCount[i] != 1, "Vertex %d has 1 child", i);
        inf.readInt(1, maxw, "w[" + to_string(i) + "]");
        readSpaceOrEndl(i == n - 1);
    }
    
    inf.readEof();
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    auto it = limits.find(validator.group());
    if (it != limits.end()) {
        auto[maxn, maxw] = it->second;
        read(maxn, maxw);
    } else {
        read(MAXN, MAXW);
    }
}
