#include <bits/stdc++.h>
using ll = long long;
using ld = long double;
using namespace std;

const int MAX_VERTICES = 200001;
const ll INF = (1ll << 60);

vector<int> children[MAX_VERTICES];

ll f[MAX_VERTICES * 2];
ll f2[MAX_VERTICES * 2];
int weight[MAX_VERTICES];
int n;
int subtreeSize[MAX_VERTICES];

void dfs(int v, vector<int>& lst) {
    lst.push_back(weight[v]);
    for (int u : children[v]) {
        dfs(u, lst);
    }
}

int main() {
#ifdef BZ
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cout.setf(ios::fixed); cout.precision(20); cout.tie(nullptr); cin.tie(nullptr);

    cin >> n;
    ll totalCost = 0;

    for (int i = 2; i <= n; ++i) {
        int x;
        cin >> x;
        children[x].push_back(i);
    }

    for (int i = 2; i <= n; ++i) {
        cin >> weight[i];
    }

    for (int i = n; i >= 1; --i) {
        vector<vector<int>> cv;
        subtreeSize[i] = 1;
        int mx = 0;

        for (int v : children[i]) {
            subtreeSize[i] += subtreeSize[v];
            mx = max(mx, subtreeSize[v]);
            dfs(v, cv.emplace_back());
            sort(cv.back().begin(), cv.back().end());
        }

        ll cur = INF;

        int j = max(mx, subtreeSize[i] / 2);
        int m = 2 * j + 1;
        fill(f, f + m, INF);
        f[0] = 0;

        for (auto& lst : cv) {
            copy(f, f + m, f2);
            fill(f, f + m, INF);

            ll sm = 0;
            for (int x : lst) {
                sm += x;
            }

            for (int k = 0; k < m; ++k) {
                for (int l = lst.size(); l <= j && k + l < m; ++l) {
                    f[k + l] = min<ll>(f[k + l], f2[k] + sm + ll(lst[0]) * (l - lst.size()));
                }
            }
        }

        cur = min<ll>(cur, f[m - 1]);

        totalCost += cur;
    }

    cout << totalCost << "\n";
}
