#include <bits/stdc++.h>
using ll = long long;
using ld = long double;
using namespace std;

const int MAX_VERTICES = 200001;
const int INF = 1000 * 1000 * 1000 + 20;

int subtreeSize[MAX_VERTICES];
int subtreeMin[MAX_VERTICES];
ll subtreeSum[MAX_VERTICES];
int weight[MAX_VERTICES];
vector <int> children[MAX_VERTICES];

int main() {
    ios_base::sync_with_stdio(false); cout.setf(ios::fixed); cout.precision(20); cout.tie(nullptr); cin.tie(nullptr);
    int n;
    cin >> n;
    ll totalCost = 0;

    for (int i = 2; i <= n; ++i) {
        int x;
        cin >> x;
        children[x].push_back(i);
    }

    for (int i = 2; i <= n; ++i) {
        cin >> weight[i];
    }

    for (int i = n; i >= 1; --i) {
        if (!children[i].empty()) {
            subtreeSize[i] = 0;
            subtreeSum[i] = 0;
            subtreeMin[i] = weight[i];

            int maxChildSize = 0;
            int maxChildSizeVertex = 0;
            int minSubtreeCost = INF;
            int minSubtreeCost2 = INF;

            for (int u : children[i]) {
                subtreeSize[i] += subtreeSize[u];
                subtreeSum[i] += subtreeSum[u];
                if (subtreeMin[u] < minSubtreeCost2) {
                    minSubtreeCost2 = subtreeMin[u];
                }

                if (minSubtreeCost2 < minSubtreeCost) {
                    swap(minSubtreeCost, minSubtreeCost2);
                }

                if (maxChildSize < subtreeSize[u]) {
                    maxChildSize = subtreeSize[u];
                    maxChildSizeVertex = u;
                }
            }

            totalCost += subtreeSum[i];

            if (maxChildSize * 2 > subtreeSize[i]) {
                int d = maxChildSize * 2 - subtreeSize[i];
                totalCost += ll((minSubtreeCost == subtreeMin[maxChildSizeVertex]) ? minSubtreeCost2 : minSubtreeCost) * d;
            } else if (subtreeSize[i] & 1) {
                totalCost += minSubtreeCost;
            }

            subtreeMin[i] = min(subtreeMin[i], minSubtreeCost);
            ++subtreeSize[i];
            subtreeSum[i] += weight[i];
        } else {
            subtreeSize[i] = 1;
            subtreeSum[i] = weight[i];
            subtreeMin[i] = weight[i];
        }
    }

    cout << totalCost << "\n";
}
