#include <bits/stdc++.h>
using ll = long long;
using ld = long double;
using namespace std;

const int MAX_VERTICES = 20001;
const ll INF = (1ll << 60);

vector<int> children[MAX_VERTICES];

int weight[MAX_VERTICES];
int n;

void dfs(int v, vector<int>& lst) {
    lst.push_back(weight[v]);
    for (int u : children[v]) {
        dfs(u, lst);
    }
}

int main() {
#ifdef BZ
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cout.setf(ios::fixed); cout.precision(20); cout.tie(nullptr); cin.tie(nullptr);

    cin >> n;
    ll totalCost = 0;

    for (int i = 2; i <= n; ++i) {
        int x;
        cin >> x;
        children[x].push_back(i);
    }

    for (int i = 2; i <= n; ++i) {
        cin >> weight[i];
    }

    for (int i = n; i >= 1; --i) {
        vector<vector<int>> cv;

        for (int v : children[i]) {
            dfs(v, cv.emplace_back());
            sort(cv.back().begin(), cv.back().end());
        }

        vector<vector<int>::const_iterator> p;
        for (const auto& val : cv) {
            p.emplace_back(val.begin());
        }

        int nonEnd = cv.size();
        int nonEndInd = 0;

        while (nonEnd >= 2) {
            int mn1 = -1, mn2 = -1;
            for (int j = 0; j < cv.size(); ++j) {
                if (p[j] == cv[j].end()) {
                    continue;
                }

                if (mn2 == -1 || *p[j] < *p[mn2]) {
                    mn2 = j;

                    if (mn1 == -1 || *p[j] < *p[mn1]) {
                        swap(mn1, mn2);
                    }
                }
            }

            totalCost += *p[mn1]++ + *p[mn2]++;
            nonEnd = 0;

            for (int j = 0; j < cv.size(); ++j) {
                if (p[j] != cv[j].end()) {
                    ++nonEnd;
                    nonEndInd = j;
                }
            }
        }

        if (nonEnd) {
            ll cn = 0;
            while (p[nonEndInd] != cv[nonEndInd].end()) {
                totalCost += *p[nonEndInd]++;
                ++cn;
            }

            ll mn = INF;

            for (int j = 0; j < cv.size(); ++j) {
                if (j != nonEndInd) {
                    for (int x : cv[j]) {
                        mn = min(mn, static_cast<ll>(x));
                    }
                }
            }

            totalCost += cn * mn;
        }
    }

    cout << totalCost << "\n";
}
